#!/usr/bin/python

import os, sys, time, random, thread

#
## CHECK COMMAND LINE ARGUMENTS
#

if len(sys.argv) != 4:
    sys.exit("Usage: ./casino.py arm_prob_file gametime playerpath")

try: # READ PROBABILITEIS OF WINS FOR EACH ARM
    arms = map(float, file(sys.argv[1]).readlines()) 
except:
    sys.exit("ERROR: Could not read prob file %s!" % sys.argv[1])

try: # READ GAME TIME IN SECONDS
    T = float(sys.argv[2])
except:
    sys.exit("ERROR: Illegal game time %s!" % sys.argv[2])

try: # START PLAYER
    topl, frompl = os.popen2(sys.argv[3])            
except:
    sys.exit("ERROR: Could not start program %s!" % sys.argv[3])


#
# COMPREHENSIVE COMMUNICATION LAYER 
#

def tell_player(s):
    print >> topl, s
    topl.flush() # ALWAYS REMEMBER TO FLUSH

def ask_player():
    return frompl.readline()


#
# GLOBAL VARIABLES
#

sum = 0             # GATHER THE AMOUNT WON HERE
time_is_up = False    

#
# CASINO THREAD
#

def run_casino():
    try:
        global sum
        tell_player(len(arms)) # SEND NUMBER OF ARMS TO PLAYER
        tell_player(T)         # SEND GAME TIME TO PLAYER

        reward = None
        while reward != 0:
            armix = int(ask_player())  # READ ARM SELECTION
            if time_is_up:
                reward = 0
            else: # SAMPLE THE REWARD
                reward = random.random()<arms[armix] and 1 or -1 
            sum += reward
            tell_player(reward)

            print sum    # EVERY ROUND? - YOU MAY WANT TO COMMENT THIS OUT
    except Exception, e:
        print "Casino exception detected:"
        print e
        print "exiting ..."

#
# MAIN PROGRAM
#

result = None
try:
    ct = thread.start_new_thread(run_casino,()) # START CASINO
    time.sleep(T)                               # SLEEP FOR T SECONDS
    result = sum                                # COLLECT RESULT
    time_is_up = True                           # SIGNAL END OF GAME
    time.sleep(1)                               # GIVE CASINO TIME TO REACT
except Exception, e:
    print "Ooops"
    print e
    result = sum

print result
